/* jshint ignore:start */

/* jshint ignore:end */

define('dummy/app', ['exports', 'ember', 'ember/resolver', 'ember/load-initializers', 'dummy/config/environment'], function (exports, Ember, Resolver, loadInitializers, config) {

  'use strict';

  var App;

  Ember['default'].MODEL_FACTORY_INJECTIONS = true;

  App = Ember['default'].Application.extend({
    modulePrefix: config['default'].modulePrefix,
    podModulePrefix: config['default'].podModulePrefix,
    Resolver: Resolver['default']
  });

  loadInitializers['default'](App, config['default'].modulePrefix);

  exports['default'] = App;

});
define('dummy/initializers/app-version', ['exports', 'dummy/config/environment', 'ember'], function (exports, config, Ember) {

  'use strict';

  var classify = Ember['default'].String.classify;
  var registered = false;

  exports['default'] = {
    name: 'App Version',
    initialize: function initialize(container, application) {
      if (!registered) {
        var appName = classify(application.toString());
        Ember['default'].libraries.register(appName, config['default'].APP.version);
        registered = true;
      }
    }
  };

});
define('dummy/initializers/defaults', ['exports'], function (exports) {

  'use strict';

  exports['default'] = {
    after: 'meta',
    name: 'defaults',
    initialize: function initialize(container, application) {
      var meta = container.lookup('meta:main');
      meta.set('defaultTitle', 'My Custom Default Title');
      meta.reopen({
        title: function title(value) {
          return value + ' - My Website';
        }
      });
    }
  };

});
define('dummy/initializers/export-application-global', ['exports', 'ember', 'dummy/config/environment'], function (exports, Ember, config) {

  'use strict';

  exports.initialize = initialize;

  function initialize(container, application) {
    var classifiedName = Ember['default'].String.classify(config['default'].modulePrefix);

    if (config['default'].exportApplicationGlobal && !window[classifiedName]) {
      window[classifiedName] = application;
    }
  }

  ;

  exports['default'] = {
    name: 'export-application-global',

    initialize: initialize
  };

});
define('dummy/initializers/meta', ['exports', 'dummy/services/meta'], function (exports, Meta) {

  'use strict';

  exports['default'] = {
    name: 'meta',

    initialize: function initialize(container, application) {
      var meta;

      application.register('meta:main', Meta['default'].create(), { singleton: true, instantiate: false });
      application.inject('route', 'meta', 'meta:main');

      // Store default values
      meta = container.lookup('meta:main');
      meta.storeDefaultTitle();

      // Bind on didTransition
      container.lookup('router:main').on('didTransition', function () {
        meta.insert();
      });
    }
  };

});
define('dummy/router', ['exports', 'ember', 'dummy/config/environment'], function (exports, Ember, config) {

  'use strict';

  var Router = Ember['default'].Router.extend({
    location: config['default'].locationType
  });

  Router.map(function () {
    this.route('about');
    this.route('empty');
    this.route('news');
  });

  exports['default'] = Router;

});
define('dummy/routes/about', ['exports', 'ember'], function (exports, Ember) {

  'use strict';

  exports['default'] = Ember['default'].Route.extend({
    setupController: function setupController(controller, model) {
      this.get('meta').update({
        title: 'This Is About Title'
      });
    }
  });

});
define('dummy/routes/news', ['exports', 'ember'], function (exports, Ember) {

  'use strict';

  exports['default'] = Ember['default'].Route.extend({
    setupController: function setupController(controller, model) {
      this.get('meta').update({
        title: 'This Is News Title',
        description: 'This Is News Description',
        'og:image': 'https://exemple.net/latest-news.png',
        'og:description': 'News Description for Open Graph' });
    }
  });

});
define('dummy/services/meta', ['exports', 'ember'], function (exports, Ember) {

  'use strict';

  var forEach = Ember['default'].EnumerableUtils.forEach;

  exports['default'] = Ember['default'].Object.extend({
    /**
      Store the default document title
       @method storeDefaultTitle
    */
    storeDefaultTitle: function storeDefaultTitle() {
      this.set('defaultTitle', window.document.title);
    },

    /**
      Set metas to be injected
       For exemple :
       ```js
        this.get('meta').update({
          title: 'This Is News Title',
          description: 'This Is News Description',
          'og:image': 'https://exemple.net/latest-news.png'
        });
      ```
       @method update
      @param {Object} attributes
    */
    update: function update(attributes) {
      this.set('attributes', attributes);
    },

    /**
      Inject given metas in document after completed didTransition
       @method insert
    */
    insert: function insert() {
      var self = this,
          attributes = this.get('attributes') || { title: this.get('defaultTitle') },
          metas = document.querySelectorAll('meta[data-meta-meta="true"]');

      // Remove previously set metas
      forEach(metas, function (meta) {
        meta.removeAttribute('content');
      });

      // Set new metas
      Ember['default'].keys(attributes).forEach(function (key) {
        self.setMeta(key, attributes[key]);
      });

      // Reset for next transition
      this.set('attributes', null);
    },

    /**
      Returns the title, exists solely to be reopen for your needs
       @method title
    */
    title: function title(value) {
      return value;
    },

    /**
      Inject given meta in document.
       Exemple :
       ```js
        self.router.setMeta('title', 'Homepage of the Crew');
      ```
       @method setMetas
      @param {Object} attributes
    */
    setMeta: function setMeta(name, value) {
      var meta;

      if (name === 'title') {
        window.document.title = this.title(value);
      } else {
        meta = document.querySelector('meta[name="' + name + '"]');

        // Create meta tag if does not exist
        if (!meta) {
          meta = document.createElement('meta');
          meta.setAttribute('name', name);
          document.getElementsByTagName('head')[0].appendChild(meta);
        }

        meta.setAttribute('data-meta-meta', 'true');
        meta.setAttribute('content', value);
      }
    }
  });

});
define('dummy/templates/application', ['exports'], function (exports) {

  'use strict';

  exports['default'] = Ember.HTMLBars.template((function() {
    return {
      isHTMLBars: true,
      revision: "Ember@1.12.0-beta.1",
      blockParams: 0,
      cachedFragment: null,
      hasRendered: false,
      build: function build(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createElement("h2");
        dom.setAttribute(el1,"id","title");
        var el2 = dom.createTextNode("Welcome to Ember.js");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n\n");
        dom.appendChild(el0, el1);
        var el1 = dom.createComment("");
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      render: function render(context, env, contextualElement) {
        var dom = env.dom;
        var hooks = env.hooks, content = hooks.content;
        dom.detectNamespace(contextualElement);
        var fragment;
        if (env.useFragmentCache && dom.canClone) {
          if (this.cachedFragment === null) {
            fragment = this.build(dom);
            if (this.hasRendered) {
              this.cachedFragment = fragment;
            } else {
              this.hasRendered = true;
            }
          }
          if (this.cachedFragment) {
            fragment = dom.cloneNode(this.cachedFragment, true);
          }
        } else {
          fragment = this.build(dom);
        }
        var morph0 = dom.createMorphAt(fragment,2,2,contextualElement);
        content(env, morph0, context, "outlet");
        return fragment;
      }
    };
  }()));

});
define('dummy/templates/news', ['exports'], function (exports) {

  'use strict';

  exports['default'] = Ember.HTMLBars.template((function() {
    return {
      isHTMLBars: true,
      revision: "Ember@1.12.0-beta.1",
      blockParams: 0,
      cachedFragment: null,
      hasRendered: false,
      build: function build(dom) {
        var el0 = dom.createDocumentFragment();
        var el1 = dom.createElement("h1");
        var el2 = dom.createTextNode("Latest News");
        dom.appendChild(el1, el2);
        dom.appendChild(el0, el1);
        var el1 = dom.createTextNode("\n");
        dom.appendChild(el0, el1);
        return el0;
      },
      render: function render(context, env, contextualElement) {
        var dom = env.dom;
        dom.detectNamespace(contextualElement);
        var fragment;
        if (env.useFragmentCache && dom.canClone) {
          if (this.cachedFragment === null) {
            fragment = this.build(dom);
            if (this.hasRendered) {
              this.cachedFragment = fragment;
            } else {
              this.hasRendered = true;
            }
          }
          if (this.cachedFragment) {
            fragment = dom.cloneNode(this.cachedFragment, true);
          }
        } else {
          fragment = this.build(dom);
        }
        return fragment;
      }
    };
  }()));

});
define('dummy/tests/app.jshint', function () {

  'use strict';

  module('JSHint - .');
  test('app.js should pass jshint', function() { 
    ok(true, 'app.js should pass jshint.'); 
  });

});
define('dummy/tests/helpers/document-meta', ['exports'], function (exports) {

  'use strict';

  exports.title = title;
  exports.description = description;
  exports.meta = meta;

  function title() {
    return document.title;
  }

  function description() {
    return document.querySelector('meta[name="description"]').getAttribute('content');
  }

  function meta(name) {
    return document.querySelector('meta[name="' + name + '"]').getAttribute('content');
  }

});
define('dummy/tests/helpers/document-meta.jshint', function () {

  'use strict';

  module('JSHint - helpers');
  test('helpers/document-meta.js should pass jshint', function() { 
    ok(true, 'helpers/document-meta.js should pass jshint.'); 
  });

});
define('dummy/tests/helpers/resolver', ['exports', 'ember/resolver', 'dummy/config/environment'], function (exports, Resolver, config) {

  'use strict';

  var resolver = Resolver['default'].create();

  resolver.namespace = {
    modulePrefix: config['default'].modulePrefix,
    podModulePrefix: config['default'].podModulePrefix
  };

  exports['default'] = resolver;

});
define('dummy/tests/helpers/resolver.jshint', function () {

  'use strict';

  module('JSHint - helpers');
  test('helpers/resolver.js should pass jshint', function() { 
    ok(true, 'helpers/resolver.js should pass jshint.'); 
  });

});
define('dummy/tests/helpers/start-app', ['exports', 'ember', 'dummy/app', 'dummy/router', 'dummy/config/environment'], function (exports, Ember, Application, Router, config) {

  'use strict';



  exports['default'] = startApp;
  function startApp(attrs) {
    var application;

    var attributes = Ember['default'].merge({}, config['default'].APP);
    attributes = Ember['default'].merge(attributes, attrs); // use defaults, but you can override;

    Ember['default'].run(function () {
      application = Application['default'].create(attributes);
      application.setupForTesting();
      application.injectTestHelpers();
    });

    return application;
  }

});
define('dummy/tests/helpers/start-app.jshint', function () {

  'use strict';

  module('JSHint - helpers');
  test('helpers/start-app.js should pass jshint', function() { 
    ok(true, 'helpers/start-app.js should pass jshint.'); 
  });

});
define('dummy/tests/initializers/defaults.jshint', function () {

  'use strict';

  module('JSHint - initializers');
  test('initializers/defaults.js should pass jshint', function() { 
    ok(true, 'initializers/defaults.js should pass jshint.'); 
  });

});
define('dummy/tests/router.jshint', function () {

  'use strict';

  module('JSHint - .');
  test('router.js should pass jshint', function() { 
    ok(true, 'router.js should pass jshint.'); 
  });

});
define('dummy/tests/routes/about.jshint', function () {

  'use strict';

  module('JSHint - routes');
  test('routes/about.js should pass jshint', function() { 
    ok(true, 'routes/about.js should pass jshint.'); 
  });

});
define('dummy/tests/routes/news.jshint', function () {

  'use strict';

  module('JSHint - routes');
  test('routes/news.js should pass jshint', function() { 
    ok(true, 'routes/news.js should pass jshint.'); 
  });

});
define('dummy/tests/test-helper', ['dummy/tests/helpers/resolver', 'ember-qunit'], function (resolver, ember_qunit) {

	'use strict';



	QUnit.config.altertitle = false;ember_qunit.setResolver(resolver['default']);

});
define('dummy/tests/test-helper.jshint', function () {

  'use strict';

  module('JSHint - .');
  test('test-helper.js should pass jshint', function() { 
    ok(true, 'test-helper.js should pass jshint.'); 
  });

});
define('dummy/tests/unit/meta-meta-test', ['ember-qunit', 'qunit', 'dummy/tests/helpers/start-app', 'dummy/tests/helpers/document-meta', 'ember'], function (ember_qunit, qunit, startApp, document_meta, Ember) {

  'use strict';

  var App, Router;

  qunit.module('ember-meta-meta', {
    setup: function setup() {
      App = startApp['default']();
      Router = App.__container__.lookup('router:main');
    },
    teardown: function teardown() {
      Ember['default'].run(App, 'destroy');
    }
  });

  ember_qunit.test('Default values', function (assert) {
    assert.expect(3);

    visit('/');

    andThen(function () {
      assert.ok(document_meta.title().match(new RegExp('^My Custom Default Title - My Website')));
      assert.equal(document_meta.description(), 'This Is Default Dummy Description');
      assert.equal(document_meta.meta('og:image'), 'https://exemple.net/my-logo.png');
    });
  });

  ember_qunit.test('Visit all pages', function (assert) {
    assert.expect(14);

    visit('/news');

    andThen(function () {
      assert.ok(document_meta.title().match(new RegExp('^This Is News Title - My Website')));
      assert.equal(document_meta.description(), 'This Is News Description');
      assert.equal(document_meta.meta('og:image'), 'https://exemple.net/latest-news.png');
      // Meta not existing in initial DOM
      assert.equal(document_meta.meta('og:description'), 'News Description for Open Graph');
    });

    visit('/about');

    andThen(function () {
      assert.ok(document_meta.title().match(new RegExp('^This Is About Title - My Website')));
      assert.equal(document_meta.description(), null);
      assert.equal(document_meta.meta('og:image'), null);
      // Meta not existing in initial DOM
      assert.equal(document_meta.meta('og:description'), null);
    });

    visit('/empty');

    andThen(function () {
      assert.ok(document_meta.title().match(new RegExp('^My Custom Default Title - My Website')));
      assert.equal(document_meta.description(), null);
      assert.equal(document_meta.meta('og:image'), null);
    });

    visit('/');

    andThen(function () {
      assert.ok(document_meta.title().match(new RegExp('^My Custom Default Title - My Website')));
      assert.equal(document_meta.description(), null);
      assert.equal(document_meta.meta('og:image'), null);
    });
  });

});
define('dummy/tests/unit/meta-meta-test.jshint', function () {

  'use strict';

  module('JSHint - unit');
  test('unit/meta-meta-test.js should pass jshint', function() { 
    ok(true, 'unit/meta-meta-test.js should pass jshint.'); 
  });

});
/* jshint ignore:start */

/* jshint ignore:end */

/* jshint ignore:start */

define('dummy/config/environment', ['ember'], function(Ember) {
  var prefix = 'dummy';
/* jshint ignore:start */

try {
  var metaName = prefix + '/config/environment';
  var rawConfig = Ember['default'].$('meta[name="' + metaName + '"]').attr('content');
  var config = JSON.parse(unescape(rawConfig));

  return { 'default': config };
}
catch(err) {
  throw new Error('Could not read config from meta tag with name "' + metaName + '".');
}

/* jshint ignore:end */

});

if (runningTests) {
  require("dummy/tests/test-helper");
} else {
  require("dummy/app")["default"].create({"name":"ember-meta-meta","version":"0.1.0.a408cb45"});
}

/* jshint ignore:end */
//# sourceMappingURL=dummy.map